stages:
    - test
    - build
  
Go tests:
  stage: test
  image: golang:1.19.4
  before_script:
    - mkdir -p tmp-coverage-reports/
  script:
    - /usr/local/go/bin/go mod download
    - /usr/local/go/bin/go test $(go list ./... | grep -v authenticationservice/cmd/authentication-service) -coverprofile tmp-coverage-reports/coverage.out
    - /usr/local/go/bin/go tool cover -html=tmp-coverage-reports/coverage.out -o tmp-coverage-reports/coverage.html
  coverage: /\d+.\d+% of statements/
  artifacts:
    expire_in: 1 month
    paths:
      - tmp-coverage-reports/coverage.html
  tags:
    - docker
    - linux

Go linter:
  stage: test
  image: golangci/golangci-lint:v1.50.1
  variables:
    GIT_DEPTH: "0"
  before_script:
    - export PATH=$PATH:/usr/local/go/bin
  script:
    - golangci-lint version
    - golangci-lint run --timeout=5m --new-from-rev $(git rev-parse origin/master) --out-format code-climate > code-climate.json
  artifacts:
    reports:
      codequality: code-climate.json
  tags:
    - docker
    - linux

Build docker image:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME"
    - docker push "$CI_REGISTRY_IMAGE"
  tags:
    - docker
    - linux
  only: 
    - tags
